/*
 * Copyright 2005 Gentoo Foundation
 * Distributed under the terms of the GNU General Public License v2
 * $Header: /var/cvsroot/gentoo-projects/hardened/policycoreutils-extra/src/setexeccon.c,v 1.2 2005/02/13 04:33:33 pebenito Exp $
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <selinux/selinux.h>

int main(int argc, char **argv) 
{
	if (argc < 3) {
		fprintf(stderr, "usage: %s context executable [arg ...]\n", argv[0]);
		return 1;
	}

	if(is_selinux_enabled() == 1) {

		if (setexeccon(argv[1]) < 0) {
			perror("setexeccon");
			return 2;
		}
	}

	execvp(argv[2], &argv[2]); 

	/* shouldn't actually get this far */
	perror("execvp");
	return 3;
}
